%matlab running sine curents in phase a b and c, creating a rotating magnetic field, recording all phase voltages and
%currents for a range of locked rotor positions




% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.5a (COMSOL 3.5.0.603, $Date: 2008/12/03 17:02:19 $)
% Some geometry objects are stored in a separate file.
% The name of this file is given by the variable 'flbinaryfile'.

flclear fem

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.5';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 603;
vrsn.rcs = '$Name:  $';
vrsn.date = '$Date: 2008/12/03 17:02:19 $';
fem.version = vrsn;

flbinaryfile='abc14.mphm';

% Constants
fem.const = {'t','0[s]', ...
  'rpm','0[1/min]', ...
  'Acoil','5.018477e-5 [m^2]', ...
  'Aslot','5.5e-4[m^2]', ...
  'L','50e-3[m]', ...
  'Ja','Ia/Acoil', ...
  'Jb','Ib/Acoil', ...
  'Jc','Ic/Acoil', ...
  'Jslotmax','1e6*sqrt(2)[A/m^2]', ...
  'Icoilmax','Jslotmax*(0.5*Aslot/2)', ...
  'omegaX','200/3*2*pi[1/s]', ...
  'Ia','Icoilmax*sin(t*omegaX)', ...
  'Ib','Icoilmax*sin(t*omegaX+120/360*2*pi)', ...
  'Ic','Icoilmax*sin(t*omegaX-120/360*2*pi)', ...
  'omega','0*1*pi/180'};

% Geometry
clear draw
g103=flbinary('g103','draw',flbinaryfile);
g7=flbinary('g7','draw',flbinaryfile);
draw.s.objs = {g103,g7};
draw.s.name = {'CO1','CO2'};
draw.s.tags = {'g103','g7'};
fem.draw = draw;
fem.geom = geomgroup(fem,'imprint','off','paircand','none');

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hgrad',1.4, ...
                  'hmaxedg',[164,4e-4,165,4e-4,217,4e-4,218,4e-4,332,4e-4,333,4e-4,344,4e-4,348,4e-4]);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'PerpendicularCurrents';
appl.module = 'ACDC';
appl.sshape = 2;
appl.assignsuffix = '_emqa';
clear bnd
bnd.type = {'cont','A0'};
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,1,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,2,2,2,1,1,1,1,2,2,2,1,1,2,2,1,1,1,1,1, ...
  1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1, ...
  1,1,1,1,1,1,1,1,2,2,1,2,2,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,2,2,1,1,1, ...
  1,1,1,2,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2, ...
  2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,1,1,1,2,1, ...
  1,1,2,1,1,1,1,1,1,1,1,1];
clear pair
pair.type = 'cont';
pair.pair = 'Pair 1';
bnd.pair = pair;
appl.bnd = bnd;
clear equ
equ.magconstrel = {'fH','fH','Br','Br','mur','Br','Br','Br','Br','Br','Br','Br', ...
  'Br','Br','Br','mur','mur','mur','mur','mur','mur'};
equ.Jez = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'Jb', ...
  '-Ja','-Jb','Ja','Jc','-Jc'};
equ.sigma = {'mat4_sigma','mat4_sigma',0,0,0,0,0,0,0,0,0, ...
  0,0,0,0,0,0,0,0,0,0};
equ.epsilonr = {'mat4_epsilonr','mat4_epsilonr',1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1};
equ.mur = {1,2000,1.05,1.05,1,1.05,1.05,1.05,1.05,1.05, ...
  1.05,1.05,1.05,1.05,1.05,1,1,1,1,1,1};
equ.normfH = {'mat4_HB1(normB_emqa[1/T])[A/m]','mat4_HB1(normB_emqa[1/T])[A/m]', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa'};
equ.Br = {{0;0},{0;0},{'1.16*sin(195*pi/180)';'-1.16*cos(195*pi/180)'}, ...
  {'1.16*-sin(165*pi/180)';'1.16*cos(165*pi/180)'},{0;0},{'1.16*-sin(225*pi/180)'; ...
  '1.16*cos(225*pi/180)'},{'1.16*sin(135*pi/180)';'-1.16*cos(135*pi/180)'}, ...
  {'1.16*sin(255*pi/180)';'-1.16*cos(255*pi/180)'},{'1.16*-sin(105*pi/180)'; ...
  '1.16*cos(105*pi/180)'},{'1.16*-sin(285*pi/180)';'1.16*cos(285*pi/180)'}, ...
  {'1.16*sin(75*pi/180)';'-1.16*cos(75*pi/180)'},{'1.16*sin(315*pi/180)'; ...
  '-1.16*cos(315*pi/180)'},{'1.16*-sin(45*pi/180)';'1.16*cos(45*pi/180)'}, ...
  {'1.16*-sin(345*pi/180)';'1.16*cos(345*pi/180)'},{'1.16*sin(15*pi/180)'; ...
  '-1.16*cos(15*pi/180)'},{0;0},{0;0},{0;0},{0;0},{0;0}, ...
  {0;0}};
equ.ind = [1,2,1,3,4,2,2,5,1,1,6,7,2,2,5,1,1,8,9,2,2,10,11,2,2,1,1,12, ...
  13,2,2,14,15,2,1,1,1,1,16,17,18,19,20,21,21,20,19,18,17,16,16,17,18,19, ...
  20,21,21,20,19,18,17,16,2,5];
appl.equ = equ;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'MovingMesh';
appl.sdim = {'X','Y','Z'};
appl.shape = {'shlag(2,''lm3'')','shlag(2,''lm4'')','shlag(2,''x'')','shlag(2,''y'')'};
appl.gporder = {30,4};
appl.cporder = 2;
appl.assignsuffix = '_ale';
clear prop
clear weakconstr
weakconstr.value = 'on';
weakconstr.dim = {'lm3','lm4'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.defflag = {{1;1},{1;1},{1;1},{1;1},{1;1},{0;0}};
bnd.wcshape = [1;2];
bnd.name = {'fixed','rotate_CCW','rotate_CW','angle_CCW','angle_CW',''};
bnd.deform = {{0;0},{'cos(2*pi*rpm*t)*X-sin(2*pi*rpm*t)*Y-X';'sin(2*pi*rpm*t)*X+cos(2*pi*rpm*t)*Y-Y'}, ...
  {'cos(-2*pi*rpm*t)*X-sin(-2*pi*rpm*t)*Y-X';'sin(-2*pi*rpm*t)*X+cos(-2*pi*rpm*t)*Y-Y'}, ...
  {'cos(omega)*X-sin(omega)*Y-X';'sin(omega)*X+cos(omega)*Y-Y'},{'cos(-omega)*X-sin(-omega)*Y-X'; ...
  'sin(-omega)*X+cos(-omega)*Y-Y'},{0;0}};
bnd.ind = [6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6];
clear pair
pair.pair = 'Pair 1';
bnd.pair = pair;
appl.bnd = bnd;
clear equ
equ.gporder = 2;
equ.presexpr = {{0;0},{'cos(omega)*X-sin(omega)*Y-X';'sin(omega)*X+cos(omega)*Y-Y'}, ...
  {'cos(2*pi*rpm*t)*X-sin(2*pi*rpm*t)*Y-X';'sin(2*pi*rpm*t)*X+cos(2*pi*rpm*t)*Y-Y'}, ...
  {0;0},{'cos(-2*pi*rpm*t)*X-sin(-2*pi*rpm*t)*Y-X';'sin(-2*pi*rpm*t)*X+cos(-2*pi*rpm*t)*Y-Y'}, ...
  {'cos(-omega)*X-sin(-omega)*Y-X';'sin(-omega)*X+cos(-omega)*Y-Y'}};
equ.name = {'default','angle_CCW','rotate_CCW','fixed','rotate_CW','angle_CW'};
equ.shape = [3;4];
equ.type = {'none','pres','pres','none','pres','pres'};
equ.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2];
appl.equ = equ;
fem.appl{2} = appl;
fem.sdim = {{'X','Y'},{'x','y'}};
fem.frame = {'ref','ale'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Boundary settings
clear bnd
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1];
bnd.dim = {'Az','x','y','lm3','lm4'};

% Boundary pairs
clear pair
pair{1}.type= 'identity';
pair{1}.name= 'Pair 1';
pair{1}.src.dl = [164,165,217,218];
pair{1}.src.operator = 'src2dst_ip2';
pair{1}.dst.dl = [332,333,344,348];
pair{1}.dst.operator = 'dst2src_ip2';
bnd.pair = pair;

fem.bnd = bnd;

% Point settings
clear pnt
pnt.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1];
pnt.dim = {'Az','x','y'};

% Point pairs
clear pair
pair{1}.type= 'identity';
pair{1}.name= 'Pair 1';
pair{1}.src.dl = [61,141,142,218];
pair{1}.src.operator = 'src2dst_ip1';
pair{1}.dst.dl = [276,296,301,321];
pair{1}.dst.operator = 'dst2src_ip1';
pnt.pair = pair;

fem.pnt = pnt;

% Coupling variable elements
clear elemcpl
% Integration coupling variables
clear elem
elem.elem = 'elcplscalar';
elem.g = {'1'};
src = cell(1,1);
clear equ
equ.expr = {{{},{},{},{},{},{},{},{},'Ez_emqa*L/Acoil', ...
  '-Ez_emqa*L/Acoil'},{{},{},{},'-Ez_emqa*L/Acoil',{},'Ez_emqa*L/Acoil', ...
  {},{},{},{}},{{},{},'Ez_emqa*L/Acoil',{},'-Ez_emqa*L/Acoil',{},{},{},{}, ...
  {}},{{},{},{},{},{},{},'Ez_emqa*L/Acoil','-Ez_emqa*L/Acoil',{},{}},{{}, ...
  {},{},'-Ez_emqa*L/Acoil',{},'Ez_emqa*L/Acoil',{},{},'Ez_emqa*L/Acoil', ...
  '-Ez_emqa*L/Acoil'}};
equ.ipoints = {{{},{},{},{},{},{},{},{},'4','4'},{{},{},{},'4',{},'4',{},{}, ...
  {},{}},{{},{},'4',{},'4',{},{},{},{},'4'},{{},{},{},{},{},{},'4','4',{}, ...
  '4'},{{},{},{},'4',{},'4',{},{},'4','4'}};
equ.frame = {{{},'ref',{},{},{},{},{},{},'ref','ref'},{{},'ref',{},'ref', ...
  {},'ref',{},{},{},{}},{{},{},'ref',{},'ref',{},{},{},{},'ref'},{{},{},{}, ...
  {},{},{},'ref','ref',{},'ref'},{{},{},{},'ref',{},'ref',{},{},'ref', ...
  'ref'}};
equ.ind = {{'1','2','3','4','5','6','7','8','9','10','11','12','13', ...
  '14','16','17','18','19','20','21','22','23','24','25','26','27','28', ...
  '29','30','31','32','33','34','35','36','37','38','63','64'},{'15'},{'39', ...
  '50','51','62'},{'40','61'},{'41','48','53','60'},{'42','59'},{'43','46', ...
  '55','58'},{'44','45','56','57'},{'47','54'},{'49','52'}};
src{1} = {{},{},equ};
elem.src = src;
geomdim = cell(1,1);
geomdim{1} = {};
elem.geomdim = geomdim;
elem.var = {'A1','A2','B','C','A'};
elem.global = {'1','2','3','4','5'};
elem.maxvars = {};
elemcpl{1} = elem;
fem.elemcpl = elemcpl;

% Library materials
clear lib
lib.mat{1}.name='Soft Iron (without losses)';
lib.mat{1}.varname='mat1';
lib.mat{1}.variables.normfB='BH(normH[m/A])[T]';
lib.mat{1}.variables.mur='MUR(normB[1/T])';
lib.mat{1}.variables.sigma='0[S/m]';
lib.mat{1}.variables.normfH='HB(normB[1/T])[A/m]';
lib.mat{1}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='MUR';
fcns{1}.method='linear';
fcns{1}.extmethod='const';
fcns{1}.x={'1','1.1','1.2','1.3','1.4','1.5','1.6','1.7','1.8','1.9', ...
  '2.0','2.1','2.2','2.3','2.4'};
fcns{1}.data={'1200','820','560','420','290','220','160','110','70','47', ...
  '26','15','10','7','6'};
fcns{2}.type='interp';
fcns{2}.name='HB';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','1','1.1','1.2','1.3','1.4','1.5','1.6','1.7','1.8', ...
  '1.9','2.0','2.1','2.2','2.3','2.4'};
fcns{2}.data={'0','663.146','1067.5','1705.23','2463.11','3841.67', ...
  '5425.74','7957.75','12298.3','20462.8','32169.6','61213.4','111408', ...
  '175070','261469','318310'};
fcns{3}.type='interp';
fcns{3}.name='BH';
fcns{3}.method='linear';
fcns{3}.extmethod='interior';
fcns{3}.x={'0','663.146','1067.5','1705.23','2463.11','3841.67', ...
  '5425.74','7957.75','12298.3','20462.8','32169.6','61213.4','111408', ...
  '175070','261469','318310'};
fcns{3}.data={'0','1','1.1','1.2','1.3','1.4','1.5','1.6','1.7','1.8', ...
  '1.9','2.0','2.1','2.2','2.3','2.4'};
lib.mat{1}.functions = fcns;
lib.mat{2}.name='FSPM_Iron';
lib.mat{2}.varname='mat2';
lib.mat{2}.variables.normfB='BH1(normH_emnc[m/A])[T]';
lib.mat{2}.variables.sigma='0[S/m]';
lib.mat{2}.variables.normfH='HB1(normB_emqa[1/T])[A/m]';
lib.mat{2}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='BH1';
fcns{1}.method='linear';
fcns{1}.extmethod='interior';
fcns{1}.x={'0','10000','12000','15000','20000','30000','40000','50000', ...
  '60000','70000','80000','90000','100000','200000','300000','400000', ...
  '500000','600000','700000','800000','900000','1000000'};
fcns{1}.data={'0','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.002','2.003','2.003'};
fcns{2}.type='interp';
fcns{2}.name='HB1';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','0.017','0.08','0.245','0.526','0.761','0.845','0.992', ...
  '1.080','1.187','1.248','1.314','1.362','1.407','1.457','1.502','1.526', ...
  '1.618','1.686','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.003'};
fcns{2}.data={'0','10','30','50','70','90','100','125','150','200','250', ...
  '350','500','750','1250','2000','2500','5000','7500','10000','12000', ...
  '15000','20000','30000','40000','50000','60000','70000','80000','90000', ...
  '100000','200000','300000','400000','500000','600000','800000','1000000'};
lib.mat{2}.functions = fcns;
lib.mat{3}.name='FSPM_Iron_1';
lib.mat{3}.varname='mat3';
lib.mat{3}.variables.normfB='BH1(normH_emnc[m/A])[T]';
lib.mat{3}.variables.sigma='0[S/m]';
lib.mat{3}.variables.normfH='HB1(normB_emqa[1/T])[A/m]';
lib.mat{3}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='BH1';
fcns{1}.method='linear';
fcns{1}.extmethod='interior';
fcns{1}.x={'0','10000','12000','15000','20000','30000','40000','50000', ...
  '60000','70000','80000','90000','100000','200000','300000','400000', ...
  '500000','600000','700000','800000','900000','1000000'};
fcns{1}.data={'0','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.002','2.003','2.003'};
fcns{2}.type='interp';
fcns{2}.name='HB1';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','0.017','0.08','0.245','0.526','0.761','0.845','0.992', ...
  '1.080','1.187','1.248','1.314','1.362','1.407','1.457','1.502','1.526', ...
  '1.618','1.686','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.003'};
fcns{2}.data={'0','10','30','50','70','90','100','125','150','200','250', ...
  '350','500','750','1250','2000','2500','5000','7500','10000','12000', ...
  '15000','20000','30000','40000','50000','60000','70000','80000','90000', ...
  '100000','200000','300000','400000','500000','600000','800000','1000000'};
lib.mat{3}.functions = fcns;
lib.mat{4}.name='FSPM_Iron_2';
lib.mat{4}.varname='mat4';
lib.mat{4}.variables.normfB='(BH1(normH_emnc[m/A])+(4*pi*1e-7)*normH_emnc[m/A])[T]';
lib.mat{4}.variables.sigma='0[S/m]';
lib.mat{4}.variables.normfH='HB1(normB_emqa[1/T])[A/m]';
lib.mat{4}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='BH1';
fcns{1}.method='linear';
fcns{1}.extmethod='interior';
fcns{1}.x={'0','10000','12000','15000','20000','30000','40000','50000', ...
  '60000','70000','80000','90000','100000','200000','300000','400000', ...
  '500000','600000','700000','800000','900000','1000000'};
fcns{1}.data={'0','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.002','2.003','2.003'};
fcns{2}.type='interp';
fcns{2}.name='HB1';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','0.017','0.08','0.245','0.526','0.761','0.845','0.992', ...
  '1.080','1.187','1.249','1.314','1.363','1.408','1.458','1.505','1.529', ...
  '1.624','1.695','1.758','1.799','1.843','1.892','1.948','1.984','2.011', ...
  '2.033','2.052','2.070','2.086','2.102','2.242','2.373','2.502','2.628', ...
  '2.755','2.881','3.008','3.134','3.260'};
fcns{2}.data={'0','10','30','50','70','90','100','125','150','200','250', ...
  '350','500','750','1250','2000','2500','5000','7500','10000','12000', ...
  '15000','20000','30000','40000','50000','60000','70000','80000','90000', ...
  '100000','200000','300000','400000','500000','600000','700000','800000', ...
  '900000','1000000'};
lib.mat{4}.functions = fcns;
lib.matgroups{1}.name='Electromagnetic (AC/DC)';
lib.matgroups{1}.variables={'alphares','T0','res0','Br','normfH','fH','normfB','fB'};
lib.matgroups{1}.descr={'Temperature coefficient','Reference temperature','Resistivity at reference temperature','Remanent flux density','Nonlinear magnetic field, norm','Nonlinear magnetic field','Nonlinear magnetic flux density, norm','Nonlinear magnetic flux density'};


fem.lib = lib;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
fem.sol=femstatic(fem, ...
                  'solcomp',{'Az'}, ...
                  'outcomp',{'Az'}, ...
                  'blocksize','auto', ...
                  'maxiter',100);

% Save current fem structure for restart purposes
fem0=fem;

% Plot solution
% postplot(fem, ...
%          'tridata',{'normB_emqa','cont','internal','unit','T'}, ...
%          'trimap','Rainbow', ...
%          'title','Surface: Magnetic flux density, norm [T]', ...
%          'axis',[-0.09390545557401893,-0.0255028338892704,-0.013522733635799866,0.023218278506750706]);

posisjon=0;
for vinkel=0:0.36:36
    posisjon=posisjon+1


% Constants
fem.const = {'t','0[s]', ...
  'rpm','0[1/min]', ...
  'Acoil','5.018477e-5 [m^2]', ...
  'Aslot','5.5e-4[m^2]', ...
  'L','50e-3[m]', ...
  'Ja','Ia/Acoil', ...
  'Jb','Ib/Acoil', ...
  'Jc','Ic/Acoil', ...
  'Jslotmax','1e6*sqrt(2)[A/m^2]', ...
  'Icoilmax','Jslotmax*(0.5*Aslot/2)', ...
  'omegaX','200/3*2*pi[1/s]', ...
  'Ia','Icoilmax*sin(t*omegaX)', ...
  'Ib','Icoilmax*sin(t*omegaX+120/360*2*pi)', ...
  'Ic','Icoilmax*sin(t*omegaX-120/360*2*pi)', ...
  'omega',[num2str(vinkel) '*2*pi/360']};

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'PerpendicularCurrents';
appl.module = 'ACDC';
appl.shape = {'shlag(2,''Az'')','shlag(2,''lm1'')'};
appl.gporder = {4,30};
appl.assignsuffix = '_emqa';
clear prop
clear weakconstr
weakconstr.value = 'on';
weakconstr.dim = {'lm1','lm2'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.wcshape = 2;
bnd.type = {'cont','A0'};
bnd.wcgporder = 2;
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,1,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,2,2,2,1,1,1,1,2,2,2,1,1,2,2,1,1,1,1,1, ...
  1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1, ...
  1,1,1,1,1,1,1,1,2,2,1,2,2,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,2,2,1,1,1, ...
  1,1,1,2,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2, ...
  2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,1,1,1,2,1, ...
  1,1,2,1,1,1,1,1,1,1,1,1];
clear pair
pair.type = 'cont';
pair.pair = 'Pair 1';
bnd.pair = pair;
appl.bnd = bnd;
clear equ
equ.magconstrel = {'fH','fH','Br','Br','mur','Br','Br','Br','Br','Br','Br','Br', ...
  'Br','Br','Br','mur','mur','mur','mur','mur','mur'};
equ.Jez = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'Jb', ...
  '-Ja','-Jb','Ja','Jc','-Jc'};
equ.sigma = {'mat4_sigma','mat4_sigma',0,0,0,0,0,0,0,0,0, ...
  0,0,0,0,0,0,0,0,0,0};
equ.epsilonr = {'mat4_epsilonr','mat4_epsilonr',1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1};
equ.mur = {1,2000,1.05,1.05,1,1.05,1.05,1.05,1.05,1.05, ...
  1.05,1.05,1.05,1.05,1.05,1,1,1,1,1,1};
equ.normfH = {'mat4_HB1(normB_emqa[1/T])[A/m]','mat4_HB1(normB_emqa[1/T])[A/m]', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa'};
equ.Br = {{0;0},{0;0},{'1.16*sin(195*pi/180)';'-1.16*cos(195*pi/180)'}, ...
  {'1.16*-sin(165*pi/180)';'1.16*cos(165*pi/180)'},{0;0},{'1.16*-sin(225*pi/180)'; ...
  '1.16*cos(225*pi/180)'},{'1.16*sin(135*pi/180)';'-1.16*cos(135*pi/180)'}, ...
  {'1.16*sin(255*pi/180)';'-1.16*cos(255*pi/180)'},{'1.16*-sin(105*pi/180)'; ...
  '1.16*cos(105*pi/180)'},{'1.16*-sin(285*pi/180)';'1.16*cos(285*pi/180)'}, ...
  {'1.16*sin(75*pi/180)';'-1.16*cos(75*pi/180)'},{'1.16*sin(315*pi/180)'; ...
  '-1.16*cos(315*pi/180)'},{'1.16*-sin(45*pi/180)';'1.16*cos(45*pi/180)'}, ...
  {'1.16*-sin(345*pi/180)';'1.16*cos(345*pi/180)'},{'1.16*sin(15*pi/180)'; ...
  '-1.16*cos(15*pi/180)'},{0;0},{0;0},{0;0},{0;0},{0;0}, ...
  {0;0}};
equ.shape = 1;
equ.ind = [1,2,1,3,4,2,2,5,1,1,6,7,2,2,5,1,1,8,9,2,2,10,11,2,2,1,1,12, ...
  13,2,2,14,15,2,1,1,1,1,16,17,18,19,20,21,21,20,19,18,17,16,16,17,18,19, ...
  20,21,21,20,19,18,17,16,2,5];
appl.equ = equ;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'MovingMesh';
appl.sdim = {'X','Y','Z'};
appl.shape = {'shlag(2,''lm3'')','shlag(2,''lm4'')','shlag(2,''x'')','shlag(2,''y'')'};
appl.gporder = {30,4};
appl.cporder = 2;
appl.assignsuffix = '_ale';
clear prop
clear weakconstr
weakconstr.value = 'on';
weakconstr.dim = {'lm3','lm4'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.defflag = {{1;1},{1;1},{1;1},{1;1},{1;1},{0;0}};
bnd.wcshape = [1;2];
bnd.name = {'fixed','rotate_CCW','rotate_CW','angle_CCW','angle_CW',''};
bnd.deform = {{0;0},{'cos(2*pi*rpm*t)*X-sin(2*pi*rpm*t)*Y-X';'sin(2*pi*rpm*t)*X+cos(2*pi*rpm*t)*Y-Y'}, ...
  {'cos(-2*pi*rpm*t)*X-sin(-2*pi*rpm*t)*Y-X';'sin(-2*pi*rpm*t)*X+cos(-2*pi*rpm*t)*Y-Y'}, ...
  {'cos(omega)*X-sin(omega)*Y-X';'sin(omega)*X+cos(omega)*Y-Y'},{'cos(-omega)*X-sin(-omega)*Y-X'; ...
  'sin(-omega)*X+cos(-omega)*Y-Y'},{0;0}};
bnd.ind = [6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6];
clear pair
pair.pair = 'Pair 1';
bnd.pair = pair;
appl.bnd = bnd;
clear equ
equ.gporder = 2;
equ.presexpr = {{0;0},{'cos(omega)*X-sin(omega)*Y-X';'sin(omega)*X+cos(omega)*Y-Y'}, ...
  {'cos(2*pi*rpm*t)*X-sin(2*pi*rpm*t)*Y-X';'sin(2*pi*rpm*t)*X+cos(2*pi*rpm*t)*Y-Y'}, ...
  {0;0},{'cos(-2*pi*rpm*t)*X-sin(-2*pi*rpm*t)*Y-X';'sin(-2*pi*rpm*t)*X+cos(-2*pi*rpm*t)*Y-Y'}, ...
  {'cos(-omega)*X-sin(-omega)*Y-X';'sin(-omega)*X+cos(-omega)*Y-Y'}};
equ.name = {'default','angle_CCW','rotate_CCW','fixed','rotate_CW','angle_CW'};
equ.shape = [3;4];
equ.type = {'none','pres','pres','none','pres','pres'};
equ.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2];
appl.equ = equ;
fem.appl{2} = appl;
fem.sdim = {{'X','Y'},{'x','y'}};
fem.frame = {'ref','ale'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Boundary settings
clear bnd
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1];
bnd.dim = {'Az','lm1','x','y','lm3','lm4'};

% Boundary pairs
clear pair
pair{1}.type= 'identity';
pair{1}.name= 'Pair 1';
pair{1}.src.dl = [164,165,217,218];
pair{1}.src.operator = 'src2dst_ip2';
pair{1}.dst.dl = [332,333,344,348];
pair{1}.dst.operator = 'dst2src_ip2';
bnd.pair = pair;

fem.bnd = bnd;

% Point settings
clear pnt
pnt.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1];
pnt.dim = {'Az','x','y'};

% Point pairs
clear pair
pair{1}.type= 'identity';
pair{1}.name= 'Pair 1';
pair{1}.src.dl = [61,141,142,218];
pair{1}.src.operator = 'src2dst_ip1';
pair{1}.dst.dl = [276,296,301,321];
pair{1}.dst.operator = 'dst2src_ip1';
pnt.pair = pair;

fem.pnt = pnt;

% Coupling variable elements
clear elemcpl
% Integration coupling variables
clear elem
elem.elem = 'elcplscalar';
elem.g = {'1'};
src = cell(1,1);
clear equ
equ.expr = {{{},{},{},{},{},{},{},{},'Ez_emqa*L/Acoil', ...
  '-Ez_emqa*L/Acoil'},{{},{},{},'-Ez_emqa*L/Acoil',{},'Ez_emqa*L/Acoil', ...
  {},{},{},{}},{{},{},'Ez_emqa*L/Acoil',{},'-Ez_emqa*L/Acoil',{},{},{},{}, ...
  {}},{{},{},{},{},{},{},'Ez_emqa*L/Acoil','-Ez_emqa*L/Acoil',{},{}},{{}, ...
  {},{},'-Ez_emqa*L/Acoil',{},'Ez_emqa*L/Acoil',{},{},'Ez_emqa*L/Acoil', ...
  '-Ez_emqa*L/Acoil'}};
equ.ipoints = {{{},{},{},{},{},{},{},{},'4','4'},{{},{},{},'4',{},'4',{},{}, ...
  {},{}},{{},{},'4',{},'4',{},{},{},{},'4'},{{},{},{},{},{},{},'4','4',{}, ...
  '4'},{{},{},{},'4',{},'4',{},{},'4','4'}};
equ.frame = {{{},'ref',{},{},{},{},{},{},'ref','ref'},{{},'ref',{},'ref', ...
  {},'ref',{},{},{},{}},{{},{},'ref',{},'ref',{},{},{},{},'ref'},{{},{},{}, ...
  {},{},{},'ref','ref',{},'ref'},{{},{},{},'ref',{},'ref',{},{},'ref', ...
  'ref'}};
equ.ind = {{'1','2','3','4','5','6','7','8','9','10','11','12','13', ...
  '14','16','17','18','19','20','21','22','23','24','25','26','27','28', ...
  '29','30','31','32','33','34','35','36','37','38','63','64'},{'15'},{'39', ...
  '50','51','62'},{'40','61'},{'41','48','53','60'},{'42','59'},{'43','46', ...
  '55','58'},{'44','45','56','57'},{'47','54'},{'49','52'}};
src{1} = {{},{},equ};
elem.src = src;
geomdim = cell(1,1);
geomdim{1} = {};
elem.geomdim = geomdim;
elem.var = {'A1','A2','B','C','A'};
elem.global = {'1','2','3','4','5'};
elem.maxvars = {};
elemcpl{1} = elem;
fem.elemcpl = elemcpl;

% Library materials
clear lib
lib.mat{1}.name='Soft Iron (without losses)';
lib.mat{1}.varname='mat1';
lib.mat{1}.variables.normfB='BH(normH[m/A])[T]';
lib.mat{1}.variables.mur='MUR(normB[1/T])';
lib.mat{1}.variables.sigma='0[S/m]';
lib.mat{1}.variables.normfH='HB(normB[1/T])[A/m]';
lib.mat{1}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='MUR';
fcns{1}.method='linear';
fcns{1}.extmethod='const';
fcns{1}.x={'1','1.1','1.2','1.3','1.4','1.5','1.6','1.7','1.8','1.9', ...
  '2.0','2.1','2.2','2.3','2.4'};
fcns{1}.data={'1200','820','560','420','290','220','160','110','70','47', ...
  '26','15','10','7','6'};
fcns{2}.type='interp';
fcns{2}.name='HB';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','1','1.1','1.2','1.3','1.4','1.5','1.6','1.7','1.8', ...
  '1.9','2.0','2.1','2.2','2.3','2.4'};
fcns{2}.data={'0','663.146','1067.5','1705.23','2463.11','3841.67', ...
  '5425.74','7957.75','12298.3','20462.8','32169.6','61213.4','111408', ...
  '175070','261469','318310'};
fcns{3}.type='interp';
fcns{3}.name='BH';
fcns{3}.method='linear';
fcns{3}.extmethod='interior';
fcns{3}.x={'0','663.146','1067.5','1705.23','2463.11','3841.67', ...
  '5425.74','7957.75','12298.3','20462.8','32169.6','61213.4','111408', ...
  '175070','261469','318310'};
fcns{3}.data={'0','1','1.1','1.2','1.3','1.4','1.5','1.6','1.7','1.8', ...
  '1.9','2.0','2.1','2.2','2.3','2.4'};
lib.mat{1}.functions = fcns;
lib.mat{2}.name='FSPM_Iron';
lib.mat{2}.varname='mat2';
lib.mat{2}.variables.normfB='BH1(normH_emnc[m/A])[T]';
lib.mat{2}.variables.sigma='0[S/m]';
lib.mat{2}.variables.normfH='HB1(normB_emqa[1/T])[A/m]';
lib.mat{2}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='BH1';
fcns{1}.method='linear';
fcns{1}.extmethod='interior';
fcns{1}.x={'0','10000','12000','15000','20000','30000','40000','50000', ...
  '60000','70000','80000','90000','100000','200000','300000','400000', ...
  '500000','600000','700000','800000','900000','1000000'};
fcns{1}.data={'0','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.002','2.003','2.003'};
fcns{2}.type='interp';
fcns{2}.name='HB1';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','0.017','0.08','0.245','0.526','0.761','0.845','0.992', ...
  '1.080','1.187','1.248','1.314','1.362','1.407','1.457','1.502','1.526', ...
  '1.618','1.686','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.003'};
fcns{2}.data={'0','10','30','50','70','90','100','125','150','200','250', ...
  '350','500','750','1250','2000','2500','5000','7500','10000','12000', ...
  '15000','20000','30000','40000','50000','60000','70000','80000','90000', ...
  '100000','200000','300000','400000','500000','600000','800000','1000000'};
lib.mat{2}.functions = fcns;
lib.mat{3}.name='FSPM_Iron_1';
lib.mat{3}.varname='mat3';
lib.mat{3}.variables.normfB='BH1(normH_emnc[m/A])[T]';
lib.mat{3}.variables.sigma='0[S/m]';
lib.mat{3}.variables.normfH='HB1(normB_emqa[1/T])[A/m]';
lib.mat{3}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='BH1';
fcns{1}.method='linear';
fcns{1}.extmethod='interior';
fcns{1}.x={'0','10000','12000','15000','20000','30000','40000','50000', ...
  '60000','70000','80000','90000','100000','200000','300000','400000', ...
  '500000','600000','700000','800000','900000','1000000'};
fcns{1}.data={'0','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.002','2.003','2.003'};
fcns{2}.type='interp';
fcns{2}.name='HB1';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','0.017','0.08','0.245','0.526','0.761','0.845','0.992', ...
  '1.080','1.187','1.248','1.314','1.362','1.407','1.457','1.502','1.526', ...
  '1.618','1.686','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.003'};
fcns{2}.data={'0','10','30','50','70','90','100','125','150','200','250', ...
  '350','500','750','1250','2000','2500','5000','7500','10000','12000', ...
  '15000','20000','30000','40000','50000','60000','70000','80000','90000', ...
  '100000','200000','300000','400000','500000','600000','800000','1000000'};
lib.mat{3}.functions = fcns;
lib.mat{4}.name='FSPM_Iron_2';
lib.mat{4}.varname='mat4';
lib.mat{4}.variables.normfB='(BH1(normH_emnc[m/A])+(4*pi*1e-7)*normH_emnc[m/A])[T]';
lib.mat{4}.variables.sigma='0[S/m]';
lib.mat{4}.variables.normfH='HB1(normB_emqa[1/T])[A/m]';
lib.mat{4}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='BH1';
fcns{1}.method='linear';
fcns{1}.extmethod='interior';
fcns{1}.x={'0','10000','12000','15000','20000','30000','40000','50000', ...
  '60000','70000','80000','90000','100000','200000','300000','400000', ...
  '500000','600000','700000','800000','900000','1000000'};
fcns{1}.data={'0','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.002','2.003','2.003'};
fcns{2}.type='interp';
fcns{2}.name='HB1';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','0.017','0.08','0.245','0.526','0.761','0.845','0.992', ...
  '1.080','1.187','1.249','1.314','1.363','1.408','1.458','1.505','1.529', ...
  '1.624','1.695','1.758','1.799','1.843','1.892','1.948','1.984','2.011', ...
  '2.033','2.052','2.070','2.086','2.102','2.242','2.373','2.502','2.628', ...
  '2.755','2.881','3.008','3.134','3.260'};
fcns{2}.data={'0','10','30','50','70','90','100','125','150','200','250', ...
  '350','500','750','1250','2000','2500','5000','7500','10000','12000', ...
  '15000','20000','30000','40000','50000','60000','70000','80000','90000', ...
  '100000','200000','300000','400000','500000','600000','700000','800000', ...
  '900000','1000000'};
lib.mat{4}.functions = fcns;
lib.matgroups{1}.name='Electromagnetic (AC/DC)';
lib.matgroups{1}.variables={'alphares','T0','res0','Br','normfH','fH','normfB','fB'};
lib.matgroups{1}.descr={'Temperature coefficient','Reference temperature','Resistivity at reference temperature','Remanent flux density','Nonlinear magnetic field, norm','Nonlinear magnetic field','Nonlinear magnetic flux density, norm','Nonlinear magnetic flux density'};


fem.lib = lib;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Mapping current solution to extended mesh
init = asseminit(fem,'init',fem0.sol,'xmesh',fem0.xmesh,'blocksize','auto');

% Solve problem
fem.sol=femstatic(fem, ...
                  'init',init, ...
                  'solcomp',{'lm1','Az'}, ...
                  'outcomp',{'lm1','Az'}, ...
                  'blocksize','auto', ...
                  'maxiter',100);

% Save current fem structure for restart purposes
fem0=fem;

% Plot solution
% postplot(fem, ...
%          'tridata',{'normB_emqa','cont','internal','unit','T'}, ...
%          'trimap','Rainbow', ...
%          'title','Surface: Magnetic flux density, norm [T]', ...
%          'axis',[-0.09159150550052496,-0.027816783962764366,-0.013522733635799866,0.023218278506750706]);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'PerpendicularCurrents';
appl.module = 'ACDC';
appl.shape = {'shlag(2,''Az'')','shlag(2,''lm1'')'};
appl.gporder = {4,30};
appl.assignsuffix = '_emqa';
clear prop
prop.analysis='transient';
clear weakconstr
weakconstr.value = 'on';
weakconstr.dim = {'lm1','lm2'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.wcshape = 2;
bnd.type = {'cont','A0'};
bnd.wcgporder = 2;
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,1,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,2,2,2,1,1,1,1,2,2,2,1,1,2,2,1,1,1,1,1, ...
  1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1, ...
  1,1,1,1,1,1,1,1,2,2,1,2,2,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,2,2,1,1,1, ...
  1,1,1,2,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2, ...
  2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,1,1,1,2,1, ...
  1,1,2,1,1,1,1,1,1,1,1,1];
clear pair
pair.type = 'cont';
pair.pair = 'Pair 1';
bnd.pair = pair;
appl.bnd = bnd;
clear equ
equ.magconstrel = {'fH','fH','Br','Br','mur','Br','Br','Br','Br','Br','Br','Br', ...
  'Br','Br','Br','mur','mur','mur','mur','mur','mur'};
equ.Jez = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'Jb', ...
  '-Ja','-Jb','Ja','Jc','-Jc'};
equ.sigma = {'mat4_sigma','mat4_sigma',0,0,0,0,0,0,0,0,0, ...
  0,0,0,0,0,0,0,0,0,0};
equ.epsilonr = {'mat4_epsilonr','mat4_epsilonr',1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1};
equ.mur = {1,2000,1.05,1.05,1,1.05,1.05,1.05,1.05,1.05, ...
  1.05,1.05,1.05,1.05,1.05,1,1,1,1,1,1};
equ.normfH = {'mat4_HB1(normB_emqa[1/T])[A/m]','mat4_HB1(normB_emqa[1/T])[A/m]', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa','1/mu0_emqa*normB_emqa', ...
  '1/mu0_emqa*normB_emqa'};
equ.Br = {{0;0},{0;0},{'1.16*sin(195*pi/180)';'-1.16*cos(195*pi/180)'}, ...
  {'1.16*-sin(165*pi/180)';'1.16*cos(165*pi/180)'},{0;0},{'1.16*-sin(225*pi/180)'; ...
  '1.16*cos(225*pi/180)'},{'1.16*sin(135*pi/180)';'-1.16*cos(135*pi/180)'}, ...
  {'1.16*sin(255*pi/180)';'-1.16*cos(255*pi/180)'},{'1.16*-sin(105*pi/180)'; ...
  '1.16*cos(105*pi/180)'},{'1.16*-sin(285*pi/180)';'1.16*cos(285*pi/180)'}, ...
  {'1.16*sin(75*pi/180)';'-1.16*cos(75*pi/180)'},{'1.16*sin(315*pi/180)'; ...
  '-1.16*cos(315*pi/180)'},{'1.16*-sin(45*pi/180)';'1.16*cos(45*pi/180)'}, ...
  {'1.16*-sin(345*pi/180)';'1.16*cos(345*pi/180)'},{'1.16*sin(15*pi/180)'; ...
  '-1.16*cos(15*pi/180)'},{0;0},{0;0},{0;0},{0;0},{0;0}, ...
  {0;0}};
equ.shape = 1;
equ.ind = [1,2,1,3,4,2,2,5,1,1,6,7,2,2,5,1,1,8,9,2,2,10,11,2,2,1,1,12, ...
  13,2,2,14,15,2,1,1,1,1,16,17,18,19,20,21,21,20,19,18,17,16,16,17,18,19, ...
  20,21,21,20,19,18,17,16,2,5];
appl.equ = equ;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'MovingMesh';
appl.sdim = {'X','Y','Z'};
appl.shape = {'shlag(2,''lm3'')','shlag(2,''lm4'')','shlag(2,''x'')','shlag(2,''y'')'};
appl.gporder = {30,4};
appl.cporder = 2;
appl.assignsuffix = '_ale';
clear prop
prop.analysis='transient';
clear weakconstr
weakconstr.value = 'on';
weakconstr.dim = {'lm3','lm4'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.defflag = {{1;1},{1;1},{1;1},{1;1},{1;1},{0;0}};
bnd.wcshape = [1;2];
bnd.name = {'fixed','rotate_CCW','rotate_CW','angle_CCW','angle_CW',''};
bnd.deform = {{0;0},{'cos(2*pi*rpm*t)*X-sin(2*pi*rpm*t)*Y-X';'sin(2*pi*rpm*t)*X+cos(2*pi*rpm*t)*Y-Y'}, ...
  {'cos(-2*pi*rpm*t)*X-sin(-2*pi*rpm*t)*Y-X';'sin(-2*pi*rpm*t)*X+cos(-2*pi*rpm*t)*Y-Y'}, ...
  {'cos(omega)*X-sin(omega)*Y-X';'sin(omega)*X+cos(omega)*Y-Y'},{'cos(-omega)*X-sin(-omega)*Y-X'; ...
  'sin(-omega)*X+cos(-omega)*Y-Y'},{0;0}};
bnd.ind = [6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, ...
  6,6,6,6,6,6,6,6,6,6,6,6];
clear pair
pair.pair = 'Pair 1';
bnd.pair = pair;
appl.bnd = bnd;
clear equ
equ.gporder = 2;
equ.presexpr = {{0;0},{'cos(omega)*X-sin(omega)*Y-X';'sin(omega)*X+cos(omega)*Y-Y'}, ...
  {'cos(2*pi*rpm*t)*X-sin(2*pi*rpm*t)*Y-X';'sin(2*pi*rpm*t)*X+cos(2*pi*rpm*t)*Y-Y'}, ...
  {0;0},{'cos(-2*pi*rpm*t)*X-sin(-2*pi*rpm*t)*Y-X';'sin(-2*pi*rpm*t)*X+cos(-2*pi*rpm*t)*Y-Y'}, ...
  {'cos(-omega)*X-sin(-omega)*Y-X';'sin(-omega)*X+cos(-omega)*Y-Y'}};
equ.name = {'default','angle_CCW','rotate_CCW','fixed','rotate_CW','angle_CW'};
equ.shape = [3;4];
equ.type = {'none','pres','pres','none','pres','pres'};
equ.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2];
appl.equ = equ;
fem.appl{2} = appl;
fem.sdim = {{'X','Y'},{'x','y'}};
fem.frame = {'ref','ale'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Boundary settings
clear bnd
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1];
bnd.dim = {'Az','lm1','x','y','lm3','lm4'};

% Boundary pairs
clear pair
pair{1}.type= 'identity';
pair{1}.name= 'Pair 1';
pair{1}.src.dl = [164,165,217,218];
pair{1}.src.operator = 'src2dst_ip2';
pair{1}.dst.dl = [332,333,344,348];
pair{1}.dst.operator = 'dst2src_ip2';
bnd.pair = pair;

fem.bnd = bnd;

% Point settings
clear pnt
pnt.ind = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, ...
  1,1,1,1,1,1,1,1,1,1,1];
pnt.dim = {'Az','x','y'};

% Point pairs
clear pair
pair{1}.type= 'identity';
pair{1}.name= 'Pair 1';
pair{1}.src.dl = [61,141,142,218];
pair{1}.src.operator = 'src2dst_ip1';
pair{1}.dst.dl = [276,296,301,321];
pair{1}.dst.operator = 'dst2src_ip1';
pnt.pair = pair;

fem.pnt = pnt;

% Coupling variable elements
clear elemcpl
% Integration coupling variables
clear elem
elem.elem = 'elcplscalar';
elem.g = {'1'};
src = cell(1,1);
clear equ
equ.expr = {{{},{},{},{},{},{},{},{},'Ez_emqa*L/Acoil', ...
  '-Ez_emqa*L/Acoil'},{{},{},{},'-Ez_emqa*L/Acoil',{},'Ez_emqa*L/Acoil', ...
  {},{},{},{}},{{},{},'Ez_emqa*L/Acoil',{},'-Ez_emqa*L/Acoil',{},{},{},{}, ...
  {}},{{},{},{},{},{},{},'Ez_emqa*L/Acoil','-Ez_emqa*L/Acoil',{},{}},{{}, ...
  {},{},'-Ez_emqa*L/Acoil',{},'Ez_emqa*L/Acoil',{},{},'Ez_emqa*L/Acoil', ...
  '-Ez_emqa*L/Acoil'}};
equ.ipoints = {{{},{},{},{},{},{},{},{},'4','4'},{{},{},{},'4',{},'4',{},{}, ...
  {},{}},{{},{},'4',{},'4',{},{},{},{},'4'},{{},{},{},{},{},{},'4','4',{}, ...
  '4'},{{},{},{},'4',{},'4',{},{},'4','4'}};
equ.frame = {{{},'ref',{},{},{},{},{},{},'ref','ref'},{{},'ref',{},'ref', ...
  {},'ref',{},{},{},{}},{{},{},'ref',{},'ref',{},{},{},{},'ref'},{{},{},{}, ...
  {},{},{},'ref','ref',{},'ref'},{{},{},{},'ref',{},'ref',{},{},'ref', ...
  'ref'}};
equ.ind = {{'1','2','3','4','5','6','7','8','9','10','11','12','13', ...
  '14','16','17','18','19','20','21','22','23','24','25','26','27','28', ...
  '29','30','31','32','33','34','35','36','37','38','63','64'},{'15'},{'39', ...
  '50','51','62'},{'40','61'},{'41','48','53','60'},{'42','59'},{'43','46', ...
  '55','58'},{'44','45','56','57'},{'47','54'},{'49','52'}};
src{1} = {{},{},equ};
elem.src = src;
geomdim = cell(1,1);
geomdim{1} = {};
elem.geomdim = geomdim;
elem.var = {'A1','A2','B','C','A'};
elem.global = {'1','2','3','4','5'};
elem.maxvars = {};
elemcpl{1} = elem;
fem.elemcpl = elemcpl;

% Library materials
clear lib
lib.mat{1}.name='Soft Iron (without losses)';
lib.mat{1}.varname='mat1';
lib.mat{1}.variables.normfB='BH(normH[m/A])[T]';
lib.mat{1}.variables.mur='MUR(normB[1/T])';
lib.mat{1}.variables.sigma='0[S/m]';
lib.mat{1}.variables.normfH='HB(normB[1/T])[A/m]';
lib.mat{1}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='MUR';
fcns{1}.method='linear';
fcns{1}.extmethod='const';
fcns{1}.x={'1','1.1','1.2','1.3','1.4','1.5','1.6','1.7','1.8','1.9', ...
  '2.0','2.1','2.2','2.3','2.4'};
fcns{1}.data={'1200','820','560','420','290','220','160','110','70','47', ...
  '26','15','10','7','6'};
fcns{2}.type='interp';
fcns{2}.name='HB';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','1','1.1','1.2','1.3','1.4','1.5','1.6','1.7','1.8', ...
  '1.9','2.0','2.1','2.2','2.3','2.4'};
fcns{2}.data={'0','663.146','1067.5','1705.23','2463.11','3841.67', ...
  '5425.74','7957.75','12298.3','20462.8','32169.6','61213.4','111408', ...
  '175070','261469','318310'};
fcns{3}.type='interp';
fcns{3}.name='BH';
fcns{3}.method='linear';
fcns{3}.extmethod='interior';
fcns{3}.x={'0','663.146','1067.5','1705.23','2463.11','3841.67', ...
  '5425.74','7957.75','12298.3','20462.8','32169.6','61213.4','111408', ...
  '175070','261469','318310'};
fcns{3}.data={'0','1','1.1','1.2','1.3','1.4','1.5','1.6','1.7','1.8', ...
  '1.9','2.0','2.1','2.2','2.3','2.4'};
lib.mat{1}.functions = fcns;
lib.mat{2}.name='FSPM_Iron';
lib.mat{2}.varname='mat2';
lib.mat{2}.variables.normfB='BH1(normH_emnc[m/A])[T]';
lib.mat{2}.variables.sigma='0[S/m]';
lib.mat{2}.variables.normfH='HB1(normB_emqa[1/T])[A/m]';
lib.mat{2}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='BH1';
fcns{1}.method='linear';
fcns{1}.extmethod='interior';
fcns{1}.x={'0','10000','12000','15000','20000','30000','40000','50000', ...
  '60000','70000','80000','90000','100000','200000','300000','400000', ...
  '500000','600000','700000','800000','900000','1000000'};
fcns{1}.data={'0','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.002','2.003','2.003'};
fcns{2}.type='interp';
fcns{2}.name='HB1';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','0.017','0.08','0.245','0.526','0.761','0.845','0.992', ...
  '1.080','1.187','1.248','1.314','1.362','1.407','1.457','1.502','1.526', ...
  '1.618','1.686','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.003'};
fcns{2}.data={'0','10','30','50','70','90','100','125','150','200','250', ...
  '350','500','750','1250','2000','2500','5000','7500','10000','12000', ...
  '15000','20000','30000','40000','50000','60000','70000','80000','90000', ...
  '100000','200000','300000','400000','500000','600000','800000','1000000'};
lib.mat{2}.functions = fcns;
lib.mat{3}.name='FSPM_Iron_1';
lib.mat{3}.varname='mat3';
lib.mat{3}.variables.normfB='BH1(normH_emnc[m/A])[T]';
lib.mat{3}.variables.sigma='0[S/m]';
lib.mat{3}.variables.normfH='HB1(normB_emqa[1/T])[A/m]';
lib.mat{3}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='BH1';
fcns{1}.method='linear';
fcns{1}.extmethod='interior';
fcns{1}.x={'0','10000','12000','15000','20000','30000','40000','50000', ...
  '60000','70000','80000','90000','100000','200000','300000','400000', ...
  '500000','600000','700000','800000','900000','1000000'};
fcns{1}.data={'0','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.002','2.003','2.003'};
fcns{2}.type='interp';
fcns{2}.name='HB1';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','0.017','0.08','0.245','0.526','0.761','0.845','0.992', ...
  '1.080','1.187','1.248','1.314','1.362','1.407','1.457','1.502','1.526', ...
  '1.618','1.686','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.003'};
fcns{2}.data={'0','10','30','50','70','90','100','125','150','200','250', ...
  '350','500','750','1250','2000','2500','5000','7500','10000','12000', ...
  '15000','20000','30000','40000','50000','60000','70000','80000','90000', ...
  '100000','200000','300000','400000','500000','600000','800000','1000000'};
lib.mat{3}.functions = fcns;
lib.mat{4}.name='FSPM_Iron_2';
lib.mat{4}.varname='mat4';
lib.mat{4}.variables.normfB='(BH1(normH_emnc[m/A])+(4*pi*1e-7)*normH_emnc[m/A])[T]';
lib.mat{4}.variables.sigma='0[S/m]';
lib.mat{4}.variables.normfH='HB1(normB_emqa[1/T])[A/m]';
lib.mat{4}.variables.epsilonr='1';
clear fcns
fcns{1}.type='interp';
fcns{1}.name='BH1';
fcns{1}.method='linear';
fcns{1}.extmethod='interior';
fcns{1}.x={'0','10000','12000','15000','20000','30000','40000','50000', ...
  '60000','70000','80000','90000','100000','200000','300000','400000', ...
  '500000','600000','700000','800000','900000','1000000'};
fcns{1}.data={'0','1.745','1.784','1.824','1.866','1.911','1.934','1.948', ...
  '1.957','1.964','1.969','1.973','1.976','1.991','1.996','1.999','2.000', ...
  '2.001','2.002','2.002','2.003','2.003'};
fcns{2}.type='interp';
fcns{2}.name='HB1';
fcns{2}.method='linear';
fcns{2}.extmethod='interior';
fcns{2}.x={'0','0.017','0.08','0.245','0.526','0.761','0.845','0.992', ...
  '1.080','1.187','1.249','1.314','1.363','1.408','1.458','1.505','1.529', ...
  '1.624','1.695','1.758','1.799','1.843','1.892','1.948','1.984','2.011', ...
  '2.033','2.052','2.070','2.086','2.102','2.242','2.373','2.502','2.628', ...
  '2.755','2.881','3.008','3.134','3.260'};
fcns{2}.data={'0','10','30','50','70','90','100','125','150','200','250', ...
  '350','500','750','1250','2000','2500','5000','7500','10000','12000', ...
  '15000','20000','30000','40000','50000','60000','70000','80000','90000', ...
  '100000','200000','300000','400000','500000','600000','700000','800000', ...
  '900000','1000000'};
lib.mat{4}.functions = fcns;
lib.matgroups{1}.name='Electromagnetic (AC/DC)';
lib.matgroups{1}.variables={'alphares','T0','res0','Br','normfH','fH','normfB','fB'};
lib.matgroups{1}.descr={'Temperature coefficient','Reference temperature','Resistivity at reference temperature','Remanent flux density','Nonlinear magnetic field, norm','Nonlinear magnetic field','Nonlinear magnetic flux density, norm','Nonlinear magnetic flux density'};


fem.lib = lib;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
fem.sol=femtime(fem, ...
                'init',fem0.sol, ...
                'solcomp',{'lm1','Az'}, ...
                'outcomp',{'lm1','Az','lm1t','Azt'}, ...
                'blocksize','auto', ...
                'tlist',[colon(0,0.015/71,0.015)], ...
                'tout','tlist', ...
                'atol',{'0.001'}, ...
                'maxstep',0.00021, ...
                'nlsolver','manual', ...
                'useratelimit','off', ...
                'ntolfact',0.0002, ...
                'maxiter',15, ...
                'dtech','autodamp', ...
                'jtech','onevery');

% Save current fem structure for restart purposes
fem0=fem;

% Plot solution
% postplot(fem, ...
%          'tridata',{'normB_emqa','cont','internal','unit','T'}, ...
%          'trimap','Rainbow', ...
%          'solnum','end', ...
%          'title','Time=0.015    Surface: Magnetic flux density, norm [T]', ...
%          'axis',[-0.09159150550052496,-0.027816783962764366,-0.013522733635799866,0.023218278506750706]);
     
     for teller=1:72

        abc.V.a(posisjon,teller)=postint(fem,'A', ...
            'unit','A', ...
            'recover','off', ...
            'dl',275, ...
            'edim',0, ...
            'solnum',teller);

        abc.V.b(posisjon,teller)=postint(fem,'B', ...
            'unit','A', ...
            'recover','off', ...
            'dl',275, ...
            'edim',0, ...
            'solnum',teller);

        abc.V.c(posisjon,teller)=postint(fem,'C', ...
            'unit','A', ...
            'recover','off', ...
            'dl',275, ...
            'edim',0, ...
            'solnum',teller);

        abc.I.a(posisjon,teller)=postint(fem,'Ia', ...
            'unit','A', ...
            'recover','off', ...
            'dl',275, ...
            'edim',0, ...
            'solnum',teller);

        abc.I.b(posisjon,teller)=postint(fem,'Ib', ...
            'unit','A', ...
            'recover','off', ...
            'dl',275, ...
            'edim',0, ...
            'solnum',teller);

        abc.I.c(posisjon,teller)=postint(fem,'Ic', ...
            'unit','A', ...
            'recover','off', ...
            'dl',275, ...
            'edim',0, ...
            'solnum',teller);

    end
    abc.omega(posisjon)=vinkel;


end
