%function taking in results from locked rotor simulations with an a phase current such as a10.m (a finished simulation in a10.mat),
%calculating inductances and plotting the results.



teller=0;
turns=174;

frequency=66.66667;


for teller=1:length(abc.omega)
    
Vabc=[abc.V.a(teller,:);abc.V.b(teller,:);abc.V.c(teller,:)]*turns;
Iabc=[abc.I.a(teller,:);abc.I.b(teller,:);abc.I.c(teller,:)]/turns;

el_vinkel=abc.omega(teller)*10;

dq=[ 2/3*cos((el_vinkel)*pi/180)   2/3*cos((el_vinkel-120)*pi/180)   2/3*cos((el_vinkel+120)*pi/180);
    -2/3*sin((el_vinkel)*pi/180)  -2/3*sin((el_vinkel-120)*pi/180)  -2/3*sin((el_vinkel+120)*pi/180);
            1/3                          1/3                          1/3                ];
                
Idq=(dq*Iabc);
Vdq=(dq*Vabc);

dqstruct.vinkel(teller)=abc.omega(teller);
dqstruct.el_vinkel(teller)=el_vinkel;

dqstruct.I.d(teller,:)=Idq(1,:);
dqstruct.I.q(teller,:)=Idq(2,:);
dqstruct.I.zero(teller,:)=Idq(3,:);

dqstruct.V.d(teller,:)=Vdq(1,:);
dqstruct.V.q(teller,:)=Vdq(2,:);
dqstruct.V.zero(teller,:)=Vdq(3,:);
end



for teller=1:length(abc.omega)
    Z.a(teller)=(max(abc.V.a(teller,:))-min(abc.V.a(teller,:)))/(max(abc.I.a(teller,:))-min(abc.I.a(teller,:)))*174^2;
    Z.ab(teller)=(max(abc.V.b(teller,:))-min(abc.V.b(teller,:)))/(max(abc.I.a(teller,:))-min(abc.I.a(teller,:)))*174^2;
    Z.ac(teller)=(max(abc.V.c(teller,:))-min(abc.V.c(teller,:)))/(max(abc.I.a(teller,:))-min(abc.I.a(teller,:)))*174^2;
end






L.a=Z.a/(frequency*2*pi);
M.ab=-Z.ab/(frequency*2*pi);
M.ac=-Z.ac/(frequency*2*pi);



hold off
plot(abc.omega,L.a)
hold on
plot(abc.omega,M.ab,'g');
plot(abc.omega,M.ac,'r');



